/*******************************************************************************
 * FoxWeapon_GrenadeBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxWeapon_GrenadeBase extends FoxWeapon
    abstract
    native(Weapon)
    config(Weapon)
    hidecategories(Navigation);

var(Animation) WeaponAnimSet AN_Release;
var(Animation) WeaponAnimSet AN_ReequipGrenade;
var(Animation) WeaponAnimSet AN_PullPin;
var(Animation) WeaponAnimSet AN_PinPulledIdle;
var private const name FPGrenadeLocName;
var private const Vector FPGrenadeLocOffset;
var private const name TPGrenadeLocName;
var float ThrowAnimLength;
var repnotify byte GearProviderIndex;
var transient float CookStartTime;
var transient float FinalCookTime;
var transient bool bStartedCooking;
var transient bool bDoNotCook;
var bool bWantsToThrowGrenade;
var() config bool bCantCook;
var bool bReadyToThrow;
var const bool bDestroyProjectilesWithWeapon;
var transient bool bSimulatedNoAmmo;
var transient bool bGearFXAttached;
var() Rotator AdditionalTossRotation;
var() string HUDIconTextureMarkup;
var const AkEvent PullPinEvent;
var const AkEvent CookEvent;
var const AkEvent StopCookEvent;
var const float GrenadeResupplySeconds;
var transient float LastResupplyTime;
var transient array<Projectile> ProjectileArray;
var const config int ProjectilesAllowed;
var private const config float ThrowAnimTime;
var private const config float PrepareThrowTime;
var const config int ReleasePitch;
var config float LifeSpanAfterDeath;
var(MuzFlash) export editinline ParticleSystemComponent GearFXComponent;

replication
{
    // Pos:0x000
    if(bNetDirty && Role == ROLE_Authority)
        GearProviderIndex
}

simulated event ReplicatedEvent(name VarName)
{
    // End:0x7D
    if(VarName == 'AmmoLeftCount')
    {
        // End:0x7A
        if(Instigator != none)
        {
            // End:0x70
            if(Instigator.IsLocallyControlled())
            {
                FoxInventoryManager(InvManager).SelectedGearCheck();
            }
            UpdateGearWidget();
        }
    }
    // End:0xA8
    else
    {
        // End:0xA8
        if(VarName == 'GearProviderIndex')
        {
            SetGearInfo(none, GearProviderIndex);
        }
    }
    super.ReplicatedEvent(VarName);
    //return;    
}

simulated function PrepareCookFinished()
{
    //return;    
}

simulated function ReleaseCookFinished()
{
    //return;    
}

simulated function PullPinFinished()
{
    //return;    
}

simulated function PullPinOut()
{
    //return;    
}

simulated function name GetPostPullPinStateName()
{
    return 'ThrowingGrenade';
    //return ReturnValue;    
}

simulated function TimeWeaponEquipping()
{
    local FoxPawn P;

    P = FoxPawn(Instigator);
    P.bSwitchingWeapons = true;
    P.UpdateHandsIK();
    P.CurrentWeaponSwitchType = 2;
    P.AttachWeapon(self);
    EquipTime = StartWeaponEquipAnim();
    // End:0xDA
    if(EquipTime > 0.20)
    {
        SetTimer(0.20, false, 'WeaponEquipped');
    }
    // End:0xF8
    else
    {
        SetTimer(EquipTime + 0.010, false, 'WeaponEquipped');
    }
    //return;    
}

simulated function class<FoxProjectile_GrenadeBase> GetGrenadeClass()
{
    return class<FoxProjectile_GrenadeBase>(WeaponProjectiles[0]);
    //return ReturnValue;    
}

simulated function CookTimeOut()
{
    local FoxProjectile_GrenadeBase Grenade;

    ClearAllPendingFire();
    // End:0x6E
    if(((Instigator == none) || FoxPawn(Instigator).IsInjured()) || !Instigator.IsAliveAndWell())
    {
        return;
    }
    // End:0xB5
    if(Role == ROLE_Authority)
    {
        Grenade = ThrowGrenade();
        Grenade.DoExplosion();
    }
    //return;    
}

simulated function AnimNotifyThrow()
{
    //return;    
}

simulated function FoxProjectile_GrenadeBase ThrowGrenade()
{
    local Vector SpawnLoc, SpawnRot;
    local FoxProjectile_GrenadeBase NewGrenade;

    bWantsToThrowGrenade = false;
    Mesh.SetHidden(true);
    // End:0xB3
    if(((!HasAnyAmmo() || Instigator == none) || Instigator.PlayerReplicationInfo == none) || WorldInfo.NetMode == NM_Client)
    {
        ClearTimer('CookTimeOut');
        return none;
    }
    FinalCookTime = GetTimerCount('CookTimeOut');
    ClearTimer('CookTimeOut');
    // End:0x131
    if(FinalCookTime == -1.0)
    {
        FinalCookTime = class<FoxProjectile_GrenadeBase>(static.GetProjectileClass()).default.GrenadeTimerLength - 0.0010;
    }
    ConsumeAmmo(0);
    IncrementGrenadeThrown();
    SpawnLoc = GetGrenadeTossLocation();
    SpawnRot = GetGrenadeTossDirection(SpawnLoc);
    NewGrenade = FoxProjectile_GrenadeBase(Spawn(GetProjectileClass(), self,, SpawnLoc,,, true));
    TransferAudioTo(NewGrenade);
    // End:0x2B9
    if((NewGrenade != none) && !NewGrenade.bDeleteMe)
    {
        NewGrenade.Init(SpawnRot);
        NewGrenade.SetPRI(Instigator.PlayerReplicationInfo);
        // End:0x291
        if(!bCantCook)
        {
            NewGrenade.StartGrenadeTimer(FinalCookTime);
        }
        NewGrenade.SetGearIndex(GearProviderIndex);
    }
    // End:0x2F0
    if(!HasAmmo(0) && HasSpareAmmo())
    {
        PerformReload(int(GetMagazineSize()));
    }
    AddProjectile(NewGrenade);
    return NewGrenade;
    //return ReturnValue;    
}

// Export UFoxWeapon_GrenadeBase::execTransferAudioTo(FFrame&, void* const)
native function TransferAudioTo(Actor NewActor);

function DropGrenade()
{
    local FoxProjectile_GrenadeBase NewGrenade;
    local Vector SpawnLoc, SpawnRot;
    local float GrenadeTimerLength;

    GrenadeTimerLength = class<FoxProjectile_GrenadeBase>(static.GetProjectileClass()).default.GrenadeTimerLength - 0.0010;
    // End:0x5B
    if((GrenadeTimerLength < float(0)) || bCantCook)
    {
        return;
    }
    FinalCookTime = GetTimerCount('CookTimeOut');
    ClearTimer('CookTimeOut');
    // End:0xB3
    if(FinalCookTime == -1.0)
    {
        FinalCookTime = GrenadeTimerLength;
    }
    SpawnLoc = GetGrenadeTossLocation();
    SpawnRot = GetGrenadeTossDirection(SpawnLoc);
    NewGrenade = FoxProjectile_GrenadeBase(Spawn(GetProjectileClass(), self,, SpawnLoc,,, true));
    // End:0x22B
    if((NewGrenade != none) && !NewGrenade.bDeleteMe)
    {
        IncrementGrenadeThrown();
        NewGrenade.Init(SpawnRot);
        NewGrenade.SetPRI(Instigator.PlayerReplicationInfo);
        NewGrenade.Velocity = FoxPawn(Owner).Velocity;
        NewGrenade.StartGrenadeTimer(FinalCookTime);
    }
    bWantsToThrowGrenade = false;
    //return;    
}

simulated function AnimNotifyAttachGrenade()
{
    AttachNewGrenade();
    //return;    
}

simulated function AttachNewGrenade()
{
    //return;    
}

simulated function GrenadeReEquipped()
{
    local FoxPawn P;

    P = FoxPawn(Instigator);
    // End:0x4C
    if(P != none)
    {
        P.bSwitchingWeapons = false;
    }
    //return;    
}

simulated function PutDownWeapon()
{
    super.PutDownWeapon();
    StopWeaponSet(AN_Release);
    StopWeaponSet(AN_ReequipGrenade);
    StopWeaponSet(AN_PinPulledIdle);
    //return;    
}

simulated function Vector GetGrenadeTossDirection(Vector StartFireLoc)
{
    local Rotator LookDirection;

    // End:0x82
    if((Instigator.PlayerReplicationInfo != none) && Instigator.PlayerReplicationInfo.bBot)
    {
        return vector(Instigator.GetViewRotation());
    }
    // End:0xDE
    else
    {
        LookDirection = Instigator.GetViewRotation();
        LookDirection.Pitch += ReleasePitch;
        return vector(LookDirection);
    }
    //return ReturnValue;    
}

simulated function Vector GetGrenadeTossLocation()
{
    local Vector SpawnLoc;

    // End:0xA8
    if((Instigator.PlayerReplicationInfo != none) && Instigator.PlayerReplicationInfo.bBot)
    {
        Instigator.Mesh.GetSocketWorldLocationAndRotation(TPGrenadeLocName, SpawnLoc);
    }
    // End:0x104
    else
    {
        SpawnLoc = FoxPawn(Instigator).FirstPersonMesh.GetBoneLocation(FPGrenadeLocName) + FPGrenadeLocOffset;
    }
    return SpawnLoc;
    //return ReturnValue;    
}

simulated function Vector GetPhysicalFireStartLoc(optional Vector AimDir)
{
    return GetGrenadeTossLocation();
    //return ReturnValue;    
}

simulated function Vector GetMuzzleLoc()
{
    local Vector Loc, X, Y, Z;
    local Rotator Rot;

    // End:0x11F
    if(FoxPawn(Instigator) != none)
    {
        FoxPawn(Instigator).Mesh.GetSocketWorldLocationAndRotation(TPGrenadeLocName, Loc, Rot);
        GetAxes(Rot, X, Y, Z);
        return ((Loc + (FireOffset.X * X)) + (FireOffset.Y * Y)) + (FireOffset.Z * Z);
    }
    // End:0x129
    else
    {
        return Location;
    }
    //return ReturnValue;    
}

simulated function PlayFireEffects(byte FireModeNum, optional Vector HitLocation)
{
    super(Weapon).PlayFireEffects(FireModeNum, HitLocation);
    //return;    
}

simulated event ToggleZoomCard(bool bSetHidden)
{
    //return;    
}

function int AddAmmo(int Amount)
{
    local int AmmoAdded, WepMagSize, OldCount, Result;

    // End:0xD6
    if((GetMaxSpareAmmoSize()) <= 0)
    {
        AmmoAdded = 0;
        WepMagSize = int(GetMagazineSize());
        // End:0xC0
        if(AmmoLeftCount < WepMagSize)
        {
            OldCount = AmmoLeftCount;
            AmmoLeftCount = Min(AmmoLeftCount + Amount, WepMagSize);
            AmmoAdded = AmmoLeftCount - OldCount;
            AmmoUsedCount = WepMagSize - AmmoLeftCount;
        }
        Result = AmmoAdded;
    }
    // End:0xF3
    else
    {
        Result = super.AddAmmo(Amount);
    }
    UpdateGearWidget();
    return Result;
    //return ReturnValue;    
}

function AddProjectile(Projectile P)
{
    local Projectile FristProjectile;

    // End:0x97
    if(ProjectilesAllowed > 0)
    {
        ProjectileArray.RemoveItem(none);
        ProjectileArray.AddItem(P);
        J0x33:
        // End:0x97 [Loop If]
        if(ProjectileArray.Length > ProjectilesAllowed)
        {
            FristProjectile = ProjectileArray[0];
            ProjectileArray.Remove(0, 1);
            // End:0x94
            if(FristProjectile != none)
            {
                FristProjectile.Destroy();
            }
            // [Loop Continue]
            goto J0x33;
        }
    }
    //return;    
}

reliable server function ServerStartCooking()
{
    // End:0x8A
    if(((HasAnyAmmo()) && !bCantCook) && WeaponProjectiles.Length > CurrentFireMode)
    {
        SetTimer(class<FoxProjectile_GrenadeBase>(WeaponProjectiles[CurrentFireMode]).default.GrenadeTimerLength, false, 'CookTimeOut');
        FinalCookTime = 0.0;
    }
    //return;    
}

simulated function OnWeaponSelect()
{
    // End:0x72
    if(Instigator.IsLocallyControlled())
    {
        // End:0x45
        if(PullPinEvent != none)
        {
            PostAkEvent(PullPinEvent);
        }
        // End:0x68
        if(CookEvent != none)
        {
            PostAkEvent(CookEvent);
        }
        ActivateEmissive();
    }
    // End:0x8B
    if(!bCantCook)
    {
        ServerStartCooking();
    }
    //return;    
}

simulated function OnReleaseWeaponSelect()
{
    bQuickThrow = true;
    // End:0x28
    if(IsInState('Active'))
    {
        StartFire(3);
    }
    //return;    
}

simulated function EndFire(byte FireModeNum)
{
    bReadyToThrow = true;
    super(Weapon).EndFire(FireModeNum);
    //return;    
}

simulated function BeginFire(byte FireModeNum)
{
    bReadyToThrow = false;
    super(Weapon).BeginFire(FireModeNum);
    //return;    
}

simulated function bool ShouldRefire()
{
    return false;
    //return ReturnValue;    
}

simulated function bool CanFireWeapon()
{
    // End:0x1E
    if((IsFiring()) && bDoNotCook)
    {
        return false;
    }
    return super.CanFireWeapon();
    //return ReturnValue;    
}

simulated event int GetAmmoUsedCount()
{
    // End:0x1A
    if(bSimulatedNoAmmo)
    {
        return int(GetMagazineSize());
    }
    return AmmoUsedCount;
    //return ReturnValue;    
}

// Export UFoxWeapon_GrenadeBase::execGetFormattedWeaponStats(FFrame&, void* const)
native function bool GetFormattedWeaponStats(out array<StatPanelEntry> StatEntries);

simulated function Destroyed()
{
    local int I;

    // End:0xF6
    if((Role == ROLE_Authority) && bDestroyProjectilesWithWeapon)
    {
        I = ProjectileArray.Length - 1;
        J0x3A:
        // End:0xF6 [Loop If]
        if(I > -1)
        {
            // End:0xAD
            if(FoxProjectile_GrenadeBase(ProjectileArray[I]) != none)
            {
                FoxProjectile_GrenadeBase(ProjectileArray[I]).SetRemovalTimer(LifeSpanAfterDeath);
            }
            // End:0xE8
            else
            {
                // End:0xE8
                if(ProjectileArray[I] != none)
                {
                    ProjectileArray[I].Destroy();
                }
            }
            -- I;
            // [Loop Continue]
            goto J0x3A;
        }
    }
    super.Destroyed();
    //return;    
}

function IncrementGrenadeThrown()
{
    //return;    
}

simulated event AutoSwitchWeapon()
{
    bQuickThrow = false;
    LastUsedWeapon();
    //return;    
}

simulated function UpdateGearWidget()
{
    local FoxPC PC;

    // End:0x189
    foreach LocalPlayerControllers(class'FoxPC', PC)
    {
        // End:0x188
        if((((PC.DynamicUI != none) && PC.DynamicUI.HUD != none) && PC.DynamicUI.HUD.GearWidget != none) && (PC.Pawn == Instigator) || PC.ViewTarget == Instigator)
        {
            PC.DynamicUI.HUD.GearWidget.UpdateGear();
        }        
    }    
    //return;    
}

simulated function int FillAmmo()
{
    return AddAmmo(int((GetMagazineSize()) + float(default.MaxSpareAmmo)));
    //return ReturnValue;    
}

simulated function SetGearInfo(FoxDataProvider_Gear_Attachment MyGearProvider, byte GearIndex)
{
    local FoxDataStore_Unlockables UnlockablesDataStore;
    local SkeletalMesh NewMesh;
    local int I;

    // End:0xB4
    if((MyGearProvider == none) && GearIndex != 255)
    {
        UnlockablesDataStore = FoxDataStore_Unlockables(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxUnlockables'));
        MyGearProvider = FoxDataProvider_Gear_Attachment(UnlockablesDataStore.AttachmentProviderArray[GearIndex]);
    }
    // End:0x24F
    if(MyGearProvider.bHasSpecialFX)
    {
        GearProviderIndex = GearIndex;
        bGearFXAttached = MyGearProvider.SetFPGearFX(self);
        ShowGearFX(IsInState('Active'));
        // End:0x24F
        if(MyGearProvider.FPMeshPath != "")
        {
            NewMesh = SkeletalMesh(DynamicLoadObject(MyGearProvider.FPMeshPath, class'SkeletalMesh', false));
            // End:0x24F
            if(NewMesh != none)
            {
                SkeletalMeshComponent(Mesh).SetSkeletalMesh(NewMesh);
                I = 0;
                J0x1E1:
                // End:0x245 [Loop If]
                if(I < Mesh.GetNumElements())
                {
                    Mesh.SetMaterial(I, none);
                    ++ I;
                    // [Loop Continue]
                    goto J0x1E1;
                }
                SetupWeaponCamoMIC();
            }
        }
    }
    //return;    
}

simulated event UpdateFirstPersonFOV(optional float NewFOV)
{
    NewFOV = -1.0;
    super.UpdateFirstPersonFOV(NewFOV);
    // End:0x40
    if(NewFOV < float(0))
    {
        NewFOV = FirstPersonFOV;
    }
    // End:0x89
    if(FoxFirstPersonParticleSystemComponent(GearFXComponent) != none)
    {
        FoxFirstPersonParticleSystemComponent(GearFXComponent).SetFOV(NewFOV);
    }
    //return;    
}

simulated function ShowGearFX(bool bShow)
{
    // End:0xAB
    if(bGearFXAttached)
    {
        // End:0xAB
        if(GearFXComponent != none)
        {
            // End:0x6C
            if(bShow)
            {
                GearFXComponent.SetHidden(false);
                GearFXComponent.ActivateSystem();
            }
            // End:0xAB
            else
            {
                GearFXComponent.SetHidden(true);
                GearFXComponent.DeactivateSystem();
            }
        }
    }
    //return;    
}

simulated function SetModsVisible(const bool bShowFP, const bool bShowTP)
{
    super.SetModsVisible(bShowFP, bShowTP);
    ShowGearFX(bShowFP);
    //return;    
}

simulated state Active
{
    simulated function BeginState(name PreviousStateName)
    {
        FoxInventoryManager(InvManager).LockWeaponActionSemaphore();
        // End:0x82
        if(bQuickThrow && (PreviousStateName == FiringStatesArray[3]) || PreviousStateName == FiringStatesArray[1])
        {
            LastUsedWeapon();
            bQuickThrow = false;
        }
        SetupSimulatedState();
        // End:0xC3
        if(!HasAmmo(0) && HasSpareAmmo())
        {
            PerformReload(int(GetMagazineSize()));
        }
        // End:0xF0
        if(HasAnyAmmo())
        {
            Mesh.SetHidden(false);
        }
        // End:0x11E
        if(bQuickThrow && HasAmmo(3))
        {
            StartFire(3);
        }
        // End:0x131
        else
        {
            super.BeginState(PreviousStateName);
        }
        //return;        
    }
    stop;    
}

simulated state PullPin
{
    simulated function BeginState(name PreviousStateName)
    {
        SetupSimulatedState();
        FoxPawn(Instigator).PlayFirstPersonCustomAnim(AN_PullPin.FP_Anim, AN_PullPin.RateMultiplier, AN_PullPin.BlendInTime, AN_PullPin.BlendOutTime);
        PlayWeaponAnim(AN_PullPin.WP_Anim, AN_PullPin.RateMultiplier, AN_PullPin.BlendInTime, AN_PullPin.BlendOutTime, false, true);
        // End:0x149
        if(PrepareThrowTime == 0.0)
        {
            PullPinOut();
            PullPinFinished();
        }
        SetTimer(PrepareThrowTime, false, 'PullPinFinished');
        SetTimer(PrepareThrowTime / 2.0, false, 'PullPinOut');
        FoxPawn(Instigator).CurrentZoomState = 1;
        //return;        
    }

    simulated function EndState(name NextStateName)
    {
        FoxPawn(Instigator).CurrentZoomState = 0;
        super(FoxWeapon).EndState(NextStateName);
        //return;        
    }

    simulated function PullPinOut()
    {
        // End:0x96
        if(Instigator.IsLocallyControlled() || Instigator.IsBeingFPSpectatedByLocalController())
        {
            // End:0x69
            if(PullPinEvent != none)
            {
                PostAkEvent(PullPinEvent);
            }
            // End:0x8C
            if(CookEvent != none)
            {
                PostAkEvent(CookEvent);
            }
            ActivateEmissive();
        }
        // End:0x111
        if(!bCantCook && WeaponProjectiles.Length > CurrentFireMode)
        {
            SetTimer(class<FoxProjectile_GrenadeBase>(WeaponProjectiles[CurrentFireMode]).default.GrenadeTimerLength, false, 'CookTimeOut');
            FinalCookTime = 0.0;
        }
        //return;        
    }

    simulated function EndFire(byte FireModeNum)
    {
        // End:0x97
        if(((Instigator != none) && !FoxPawn(Instigator).IsInjured()) && Instigator.IsAliveAndWell())
        {
            // End:0x88
            if(IsTimerActive('PullPinFinished'))
            {
                bReadyToThrow = true;
            }
            // End:0x97
            else
            {
                GotoState(GetPostPullPinStateName());
            }
        }
        super(FoxWeapon_GrenadeBase).EndFire(FireModeNum);
        //return;        
    }

    simulated function PullPinFinished()
    {
        bWantsToThrowGrenade = true;
        // End:0x3A
        if(bReadyToThrow || bCantCook)
        {
            GotoState(GetPostPullPinStateName());
        }
        // End:0x17C
        else
        {
            // End:0x17C
            if(AN_PinPulledIdle.FP_Anim != 'None')
            {
                FoxPawn(Instigator).PlayFirstPersonCustomAnim(AN_PinPulledIdle.FP_Anim, AN_PinPulledIdle.RateMultiplier, AN_PinPulledIdle.BlendInTime, AN_PinPulledIdle.BlendOutTime, true);
                PlayWeaponAnim(AN_PinPulledIdle.WP_Anim, AN_PinPulledIdle.RateMultiplier, AN_PinPulledIdle.BlendInTime, AN_PinPulledIdle.BlendOutTime, true, true);
            }
        }
        //return;        
    }

    simulated function CookTimeOut()
    {
        global.CookTimeOut();
        // End:0x6D
        if(WorldInfo.NetMode == NM_Client)
        {
            // End:0x6D
            if(!HasSpareAmmo() && float(SimulatedAmmoUsedCount + 1) >= (GetMagazineSize()))
            {
                bSimulatedNoAmmo = true;
            }
        }
        GotoState('Active');
        //return;        
    }

    simulated function bool TryPutDown()
    {
        // End:0x63
        if((WeaponProjectiles.Length <= CurrentFireMode) || class<FoxProjectile_GrenadeBase>(WeaponProjectiles[CurrentFireMode]).default.GrenadeTimerLength <= float(0))
        {
            PutDownWeapon();
            return true;
        }
        return super(Weapon).TryPutDown();
        //return ReturnValue;        
    }
    stop;    
}

simulated state ThrowingGrenade
{
    ignores BeginFire;

    simulated event bool IsFiring()
    {
        return true;
        //return ReturnValue;        
    }

    simulated function ReleaseCookFinished()
    {
        ClearAllPendingFire();
        // End:0x87
        if(bQuickThrow)
        {
            bQuickThrow = false;
            GotoState('Inactive');
            LastUsedWeapon();
            // End:0x85
            if(Instigator.IsLocallyControlled())
            {
                FoxInventoryManager(InvManager).SelectedGearCheck();
            }
            return;
        }
        // End:0xCA
        if(Instigator.IsHumanControlled() && HasAnyAmmo())
        {
            GotoState('EquipNextGrenade');
        }
        // End:0xD8
        else
        {
            GotoState('Active');
        }
        //return;        
    }

    simulated function BeginState(name PreviousStateName)
    {
        SetupSimulatedState();
        // End:0xC5
        if((Instigator.IsLocallyControlled() || Instigator.IsBeingFPSpectatedByLocalController()) && Instigator.IsHumanControlled())
        {
            FoxPawn(Instigator).LocalPawnDialog("Attack", 2, WeaponAttachmentClass.default.DialogName);
        }
        ReleaseCookedGrenade();
        IncrementFlashCount();
        // End:0x13C
        if(WorldInfo.NetMode == NM_Client)
        {
            // End:0x13C
            if(!HasSpareAmmo() && float(SimulatedAmmoUsedCount + 1) >= (GetMagazineSize()))
            {
                bSimulatedNoAmmo = true;
            }
        }
        // End:0x17C
        if(FoxInventoryManager(InvManager) != none)
        {
            FoxInventoryManager(InvManager).LockWeaponActionSemaphore();
        }
        // End:0x1C6
        if(((Role == ROLE_Authority) && !bCantCook) && !IsTimerActive('CookTimeOut'))
        {
            ServerStartCooking();
        }
        //return;        
    }

    simulated function EndState(name NextStateName)
    {
        ClearFlashCount();
        SetCurrentFireMode(0);
        // End:0x8A
        if(AIController(Instigator.Controller) != none)
        {
            AIController(Instigator.Controller).NotifyWeaponFinishedFiring(self, CurrentFireMode);
        }
        // End:0xCA
        if(FoxInventoryManager(InvManager) != none)
        {
            FoxInventoryManager(InvManager).UnLockWeaponActionSemaphore();
        }
        bReadyToThrow = false;
        //return;        
    }

    simulated function ReleaseCookedGrenade()
    {
        local float ReleaseAnimLength;

        bWantsToThrowGrenade = true;
        ReleaseAnimLength = PlayWeaponSet(AN_Release, 1.0);
        SetTimer(((ReleaseAnimLength > 0.10) ? ReleaseAnimLength : 0.10), false, 'ReleaseCookFinished');
        SetTimer(ThrowAnimTime, false, 'ThrowGrenade');
        //return;        
    }

    simulated function EndFire(byte FireModeNum)
    {
        super(FoxWeapon_GrenadeBase).EndFire(FireModeNum);
        //return;        
    }
    stop;    
}

simulated state WeaponEquipping
{
    simulated function BeginState(name PreviousStateName)
    {
        DeactivateEmissive();
        // End:0x41
        if(!HasAmmo(0) && HasSpareAmmo())
        {
            PerformReload(int(GetMagazineSize()));
        }
        super.BeginState(PreviousStateName);
        //return;        
    }

    simulated function BeginFire(byte FireModeNum)
    {
        global.BeginFire(FireModeNum);
        // End:0x43
        if(FireModeNum == 3)
        {
            ClearTimer('WeaponEquipped');
            WeaponEquipped();
        }
        //return;        
    }
    stop;    
}

simulated state EquipNextGrenade
{
    ignores BeginFire;

    simulated function BeginState(name PreviousStateName)
    {
        local float ReEquipTime;

        SetupSimulatedState();
        DeactivateEmissive();
        ReEquipTime = StartWeaponEquipAnim();
        Mesh.SetHidden(false);
        // End:0x73
        if(ReEquipTime > float(0))
        {
            SetTimer(ReEquipTime, false, 'GrenadeReEquipped');
        }
        // End:0x86
        else
        {
            SetTimer(0.010, false, 'GrenadeReEquipped');
        }
        //return;        
    }

    simulated function GrenadeReEquipped()
    {
        global.GrenadeReEquipped();
        SetCurrentFireMode(0);
        GotoState('Active');
        //return;        
    }

    simulated function EndFire(byte FireModeNum)
    {
        super(FoxWeapon_GrenadeBase).EndFire(FireModeNum);
        //return;        
    }
    stop;    
}

simulated state Melee
{
    simulated function EndState(name NextStateName)
    {
        ClearPendingFire(3);
        super.EndState(NextStateName);
        //return;        
    }
    stop;    
}

auto state Inactive
{
    simulated function BeginState(name PreviousStateName)
    {
        bSimulatedNoAmmo = false;
        super.BeginState(PreviousStateName);
        //return;        
    }

    reliable server function ServerStartFire(byte FireModeNum)
    {
        global.ServerStartFire(FireModeNum);
        //return;        
    }

    reliable server function ServerStopFire(byte FireModeNum)
    {
        global.ServerStopFire(FireModeNum);
        //return;        
    }
    stop;    
}

simulated state WeaponPuttingDown
{
    simulated function BeginState(name PreviousStateName)
    {
        SetupSimulatedState();
        // End:0x30
        if(HasAmmo(0))
        {
            super.BeginState(PreviousStateName);
        }
        // End:0x43
        else
        {
            SetTimer(0.010, false, 'WeaponIsDown');
        }
        //return;        
    }

    simulated function WeaponIsDown()
    {
        FoxInventoryManager(InvManager).UnLockWeaponActionSemaphore();
        super.WeaponIsDown();
        ClearPendingFire(0);
        bReadyToThrow = false;
        // End:0xD2
        if(bQuickThrow && Instigator.IsLocallyControlled() || Instigator.IsBeingFPSpectatedByLocalController())
        {
            bQuickThrow = false;
            FoxInventoryManager(InvManager).SetCurrWeapon();
        }
        //return;        
    }
    stop;    
}

defaultproperties
{
    AN_Release=(TP_Anim=(AnimName=(None,None,Quickthrow)),FP_Anim=Pin_Throw,WP_Anim=None,HG_Anim=None,RateMultiplier=1.0,BlendInTime=0.10,BlendOutTime=-1.0,AbortBlendOutTime=0.050)
    AN_ReequipGrenade=(TP_Anim=(AnimName=(None,None,Select_A)),FP_Anim=Select_A,WP_Anim=None,HG_Anim=None,RateMultiplier=1.0,BlendInTime=0.10,BlendOutTime=0.250,AbortBlendOutTime=0.10)
    AN_PullPin=(TP_Anim=(AnimName=(None,None,None)),FP_Anim=Pin_Pull,WP_Anim=None,HG_Anim=None,RateMultiplier=1.0,BlendInTime=0.10,BlendOutTime=0.050,AbortBlendOutTime=0.050)
    AN_PinPulledIdle=(TP_Anim=(AnimName=(None,None,None)),FP_Anim=None,WP_Anim=None,HG_Anim=None,RateMultiplier=1.0,BlendInTime=0.10,BlendOutTime=0.050,AbortBlendOutTime=0.050)
    FPGrenadeLocName=Camera
    FPGrenadeLocOffset=(X=0.0,Y=0.0,Z=10.0)
    TPGrenadeLocName=RightHand
    GearProviderIndex=255
    GrenadeResupplySeconds=5.0
    ProjectilesAllowed=4
    ThrowAnimTime=0.2710
    PrepareThrowTime=0.6670
    ReleasePitch=1024
    begin object name=GearFXParticleSystemComponent0 class=FoxFirstPersonParticleSystemComponent
        bAutoActivate=false
        ReplacementPrimitive=none
        TranslucencySortPriority=-1
    object end
    // Reference: FoxFirstPersonParticleSystemComponent'Default__FoxWeapon_GrenadeBase.GearFXParticleSystemComponent0'
    GearFXComponent=GearFXParticleSystemComponent0
    bEnableArmoryIdleIK=false
    bHasAimingColor=false
    bFrictionEnabled=false
    bAdhesionEnabled=false
    bSupportsBarrelMods=false
    bSupportsMagazineMods=false
    bSupportsMuzzleMods=false
    bSupportsScopeMods=false
    bSupportsStockMods=false
    bSupportsGripMods=false
    bSupportsCamo=false
    bForceIKDisabled=true
    WeaponType=EWeaponType.WT_Grenade
    MagSize=1.0
    InitialMagazines=0
    AimAssistScale=1.0
    AimAssistScaleWhileZoomed=1.0
    FireFeedbackWaveform=ForceFeedbackWaveform'Default__FoxWeapon_GrenadeBase.ForceFeedbackWaveformFire'
    TightAimCameraShake=CameraShake'Default__FoxWeapon_GrenadeBase.Shake0'
    NormalCameraShake=CameraShake'Default__FoxWeapon_GrenadeBase.Shake1'
    MuzzleSocketName=None
    MuzzleFlashLight=PointLightComponent'Default__FoxWeapon_GrenadeBase.LightComponent0'
    begin object name=LensComp class=LensFlareComponent
        NextTraceTime=-0.68861970
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxWeapon_GrenadeBase.LensComp'
    MuzzleLensFlare=LensComp
    FiringStatesArray=/* Array type was not detected. */
    WeaponFireTypes=/* Array type was not detected. */
    InstantHitDamageTypes=/* Array type was not detected. */
    begin object name=WeaponMesh class=FoxFirstPersonSkeletalMeshComponent
        bForceRefpose=1
        bNoSkeletonUpdate=true
        ReplacementPrimitive=none
        TickGroup=ETickingGroup.TG_DuringAsyncWork
    object end
    // Reference: FoxFirstPersonSkeletalMeshComponent'Default__FoxWeapon_GrenadeBase.WeaponMesh'
    Mesh=WeaponMesh
}